#include "jcabc2ps.h"
	/* added header to correct cast from integer to ptr in memBlock call
	 * - Eric Conrad 11-28-2015 */
#include "memBlock.h"

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Make sure that a Str has at least n bytes allocated.
*/
Str *minStr(
	Str *sp,
	int  n)
{	Str *r=0;
	char *F="minStr";
	if (!sp) {
		V1 "%s:### minstr(%08X,%d) called ###\n",F,sp,n V;
		return 0;
	}
	if (sp->v) {
		if (n < sp->l) return sp;
		if (n < sp->m) return sp;
	}
	++ n;		// Paranoia
	if (sp->v && sp->m) {	// Was it allocated?
		sp->v = (char*)memBlock(sp->v,sp->m,n,"minStr-grow");	/* in header memBlock.h */
	} else {		// Not allocated yet
		sp->v = (char*)memBlock(0,0,n,"minStr-init");			/* in header memBlock.h */
	}
	unless (sp->v) {
		V1 "%s: ### OUT OF MEMORY (minStr can't get %d bytes) ###\n",F,n+1 V;
		return 0;
	}
	sp->m = n;		// Use the requested length as the allocated length
	return sp;
}

